# Forex API Documentation| GMO Coin

<a id="outline"></a>
# Introduction

GMO Coin provides a Public API that does not require authentication and a Private API that requires authentication using an API key.

* All requests from the client to the API are [HTTPS](https://en.wikipedia.org/wiki/HTTPS) communication.

```javascript

//Request examples are tested with Node.js v21.0.0.

```

<a id="end-point"></a>
## Endpoint

* Public API: `https://forex-api.coin.z.com/public`
* Public WebSocket API: `wss://forex-api.coin.z.com/ws/public`
* Private API: `https://forex-api.coin.z.com/private`
* Private WebSocket API: `wss://forex-api.coin.z.com/ws/private`


<a id="version"></a>
## Version
Current version: `v1`


<a id="restrictions"></a>
## API Limiting
API usage Limits are below:

<a id="restrictions-public-ws-api"></a>
##### Public WebSocket API Limiting
* 1 request (subscribe/unsubscribe) per second from each IP address for Public WebSocket API.

<a id="restrictions-private-api"></a>
##### Private API Limiting
* Private API's limits are subject to change without prior notice.
* If you enable the IP restriction feature on the membership site, it will deny any API calling that comes from a non-registered IP.
* Only features that are specified on the membership site when API key was issued can be called.

|  Description  |
| ---- |
| Maximum 6 GET requests per second.  Maximum 1 POST requests per second. |

<a id="restrictions-private-ws-api"></a>
##### Private WebSocket API Limiting
* Private WebSocket API is limited to maximum 1 request (subscribe/unsubscribe) per second for each IP address.
* If you enable the IP restriction feature on the membership site, it will deny any API calling that comes from a non-registered IP.
* Only features specified at the time of issuing the API key can be subscribed.

<a id="restrictions-other"></a>
##### Other
We may restrict API usage due to any of the following reasons.

* To automatically limit the flow rate when our entire system experiences overload.
* We have determined the user's API usage may be causing an overload on our system.
* We have determined that users are repeatedly placing orders to intentionally overload our system.


<a id="open-account"></a>
# Opening New Accounts
If you don't have a forex account　[Sign up for free](https://coin.z.com/jp/member/home/join/fx)


<a id="api-key"></a>
# Creating API Keys
After opening forex account, you can create forex API keys from the membership site.

When you create a forex API key, you can set a permission for each functionality.

You can start 30 days free trial with creating forex API Keys.

Please check API fees for "Order" and "Change Order" via API  [here](https://coin.z.com/jp/corp/guide/fees/).

<a id="authentication"></a>
# Authentication

Authentication is not required to callout the Public API. Public API functionalities are [here](#public-api).


<a id="authentication-private"></a>
## Private API

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://END_POINT_URL';
const path      = '/v1/PATH';
const reqBody   = JSON.stringify({});

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

HTTP header requires to include information with using API key and API secret below:

* API-KEY: Access key that is issued on the membership site
* API-TIMESTAMP: The request's Unix Timestamp
* API-SIGN: Signature generated for each request with the following method

##### Signature Generation

You can generate the signature by signing a concatenated string of the request's Unix Timestamp (milliseconds), the HTTP method, the request path, and the request body with your API secret key using the HMAC-SHA256 algorithm. Please pay special attention to the following:

* For GET requests, the request body must be an empty string.
* The request path must start with `/v1` and must not start with `/private`.

<a id="authentication-private-ws"></a>
## Private WebSocket API
Using a [Private API](#ws-auth-post) to get an access token. The way of authentication for the Private API is the same as the other Private API.

<a id="public-api"></a>
# Public API


<a id="status"></a>
## Service Status

> Request example:

```javascript
const axios = require('axios');

const endPoint = 'https://forex-api.coin.z.com/public';
const path     = '/v1/status';

axios.get(endPoint + path)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });

```

> Response example:

```json
{
  "status": 0,
  "data": {
    "status": "OPEN"
  },
  "responsetime": "2019-03-19T02:15:06.001Z"
}
```

Gets the service status of GMO Coin.


##### Request
`GET /public/v1/status`


##### Parameters
None

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
status | string | Service status: `MAINTENANCE`（Service status: Maintenance） `CLOSE`（Close） `OPEN`（Open）


<a id="ticker"></a>
## Ticker

> Request example:

```javascript
const axios = require('axios');

const endPoint = 'https://forex-api.coin.z.com/public';
const path     = '/v1/ticker';

axios.get(endPoint + path)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });

```

> Response example:

```json
{
  "status": 0,
  "data": [
    {
      "ask": "137.644",
      "bid": "137.632",
      "symbol": "USD_JPY",
      "timestamp": "2018-03-30T12:34:56.789671Z",
      "status": "OPEN"
    },
    {
      "symbol": "EUR_JPY",
      "ask": "149.221",
      "bid": "149.181",
      "timestamp": "2023-05-19T02:51:24.516493Z",
      "status": "OPEN"
    }
  ],
  "responsetime": "2019-03-19T02:15:06.014Z"
}
```

Gets the latest rates of all symbols.


##### Request
`GET /public/v1/ticker`

##### Parameters
None

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
symbol | string | The handling symbols are [here](#parameters-ref)
ask | string | Current ask price.
bid | string | Current bid price.
timestamp | string | Timestamp of current rate.
status | string | Service status: `CLOSE`（Service status: Close） `OPEN`（Open）


<a id="klines"></a>
## KLine Data

> Request example:

```javascript
const axios = require('axios');

const endPoint = 'https://forex-api.coin.z.com/public';
const path     = '/v1/klines?symbol=USD_JPY&priceType=ASK&interval=1min&date=20231028';

axios.get(endPoint + path)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
    {
        "openTime":"1618588800000",
        "open":"141.365",
        "high":"141.368",
        "low":"141.360",
        "close":"141.362"
    },
    {
        "openTime":"1618588860000",
        "open":"141.362",
        "high":"141.369",
        "low":"141.361",
        "close":"141.365"
    }
  ],
  "responsetime": "2023-07-08T22:28:07.980Z"
}
```

Gets a market's OHLC of the specified symbol.


##### Request
`GET /public/v1/klines`


##### Parameters
* Parameter type: query

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`symbol`（Ticker Symbol） | string | Required | The handling symbols are [here](#parameters-ref)
`priceType`（BID/ASK） | string | Required | Specify `BID` or `ASK`
`interval`（Chart type） | string | Required |  `1min`（1minute chart） `5min`（5minute chart） `10min`（10minute chart） `15min`（15minute chart） `30min`（30minute chart） `1hour`（1hour chart） `4hour`（4hour chart） `8hour`（8hour chart） `12hour`（12hour chart） `1day`（daily chart） `1week`（weekly chart） `1month`（monthly chart）
`date`（Search date） | string | Required |   Acceptable data formats: `YYYYMMDD`（date format） `YYYY`（year format）  If `YYYYMMDD` , the following interval values are supported: `1min`（Chart type: 1minute chart） `5min`（5minute chart） `10min`（10minute chart） `15min`（15minute chart） `30min`（30minute chart） `1hour`（1hour chart）  ※The date should be equal to or after 20231028.    Date will be renewed at JST 6:00.  If `YYYY` , the following interval values are supported: `4hour`（4hour chart） `8hour`（8hour chart） `12hour`（12hour chart） `1day`（daily chart） `1week`（weekly chart） `1month`（monthly chart）   ※The date should be equal to or after the release date of each symbol.      The release date is [here](#parameters-ref).

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
openTime | string | Start unix timestamp(milliseconds)
open | string | Open price
high | string | High price
low | string | Low price
close | string | Close price

<a id="symbols"></a>
## Trade rules

> Request example:

```javascript
const axios = require('axios');

const endPoint = 'https://forex-api.coin.z.com/public';
const path     = '/v1/symbols';

axios.get(endPoint + path)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
    {
      "symbol": "USD_JPY",
      "minOpenOrderSize": "10000",
      "maxOrderSize": "500000",
      "sizeStep": "1",
      "tickSize": "0.001"
    }
  ],
  "responsetime": "2022-12-15T19:22:23.792Z"
}
```

Gets trade rules.


##### Request
`GET /public/v1/symbols`


##### Parameters
None

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
symbol | string | The handling symbols are [here](#parameters-ref)
minOpenOrderSize | string | Minimum new order size
maxOrderSize | string | Maximum order size
sizeStep | string | Minimum order value
tickSize | string | Tick size

<a id="public-ws-api"></a>
# Public WebSocket API

* A ping will be sent from the server to a client once per minute. If there's no response (pong) from a client 3 consecutive times, then the WebSocket will be disconnected automatically.


<a id="ws-ticker"></a>
## Ticker

> Request example:

```javascript
const WebSocket = require("ws");
const ws = new WebSocket("wss://forex-api.coin.z.com/ws/public/v1");

ws.on("open", () => {
    const message = JSON.stringify(
    {
        "command": "subscribe",
        "channel": "ticker",
        "symbol": "USD_JPY"
    });
    ws.send(message);
});

ws.on("message", (data) => {
    console.log("WebSocket message: ", data);
});
```

> Response example:

```json
{
  "symbol": "USD_JPY",
  "ask": "140.534",
  "bid": "140.502",
  "timestamp": "2018-03-30T12:34:56.789984Z",
  "status": "OPEN" 
}
```

Gets the latest rates of the specified symbol. 
After `subscribe`（WebSocket Command: Start subscribing）, tickers start to be sent.


##### Parameters
* Parameter type: JSON

Property Name | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
command | string | Required | `subscribe`（WebSocket Command: Start subscribing） `unsubscribe`（Stop subscribing）
channel | string | Required | `ticker`（Channel Name: Ticker）
`symbol`（Ticker Symbol） | string | Required | The handling symbols are [here](#parameters-ref)

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
symbol | string | The handling symbols are [here](#parameters-ref)
ask | string | Current ask price.
bid | string | Current bid price.
timestamp | string | Timestamp of current rate.
status | string | Service status: `CLOSE`（Service status: Close） `OPEN`（Open）

* There is no Response when `unsubscribe`（WebSocket Command: Stop subscribing） is requested.

<a id="private-api"></a>
# Private API

<a id="assets"></a>
## Assets

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'GET';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/account/assets';

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.get(endPoint + path, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });

```

> Response example:

```json
{
  "status": 0,
  "data": [
    {
      "equity": "120947776",
      "availableAmount": "89717102",
      "balance": "116884885",
      "estimatedTradeFee": "766.5",
      "margin": "31227908",
      "marginRatio": "406.3",
      "positionLossGain": "3884065.046",
      "totalSwap": "178825.439",
      "transferableAmount": "85654212"
    }
  ],
  "responsetime": "2019-03-19T02:15:06.055Z"
}
```

Retrieves asset data.


##### Request
`GET /private/v1/account/assets`


##### Parameters
None

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
equity | string | Market value
availableAmount | string | Available amount
balance | string | Cash balance
estimatedTradeFee | string | Estimated trade fee
margin | string | Margin
marginRatio | string | Margin ratio
positionLossGain | string | Appraisal loss
totalSwap | string | Unsettled swap
transferableAmount | string | Transferable amount


<a id="orders"></a>
## Orders

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp  = Date.now().toString();
const method     = 'GET';
const endPoint   = 'https://forex-api.coin.z.com/private';
const path       = '/v1/orders';
const parameters = '?orderId=123456789,223456789';

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.get(endPoint + path + parameters, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": {
    "list": [
      {
        "rootOrderId": 223456789,
        "clientOrderId": "sygngz1234",
        "orderId": 223456789,
        "symbol": "USD_JPY",
        "side": "BUY",
        "orderType": "NORMAL",
        "executionType": "LIMIT",
        "settleType": "OPEN",
        "size": "10000",
        "price": "140",
        "status": "EXECUTED",
        "expiry" : "20201113",
        "timestamp": "2020-10-14T20:18:59.343Z"
      },
      {
        "rootOrderId": 123456789,
        "orderId": 123456789,
        "symbol": "CAD_JPY",
        "side": "SELL",
        "orderType": "NORMAL",
        "executionType": "LIMIT",
        "settleType": "CLOSE",
        "size": "10000",
        "price": "110",
        "status": "CANCELED",
        "cancelType": "USER",
        "expiry" : "20201113",
        "timestamp": "2020-10-14T20:18:59.343Z"
      }
    ]
  },
  "responsetime": "2019-03-19T02:15:06.059Z"
}
```

Gets the specified order id's order information. 

* One of `rootOrderId` `orderId` is required. Both cannot be set at the same time.


##### Request
`GET /private/v1/orders`


##### Parameters
* Parameter type: query

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`rootOrderId`（Root order id） | number | * | Either `rootOrderId` or `orderId`（Order id） is required. ※A comma-separated list of order ids. The maximum number of order ids is 10.
`orderId`（Execution id） | number | * | Either `rootOrderId`（Root order id） or `orderId`（Order id） is required. ※A comma-separated list of order ids. The maximum number of order ids is 10.

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `NORMAL`（Order Type: Normal order） `OCO`（OCO order） `IFD`（IFD order） `IFDOCO`（IFDOCO order） `LOSSCUT`（Margin liquidation） 
executionType | string | Execution Type: `MARKET`（Execution Type: Market order） `LIMIT`（Limit order） `STOP`（Stop limit order）
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Quantity of the order
price | string | Price of the order ※It is returned if status is `LIMIT`（Execution Type: Limit order） or `STOP`（Stop limit order） .
status | string | Order Status: `WAITING`（Order Status: Waiting） `ORDERED`（Valid order） `MODIFYING`（Modifying） `CANCELED`（Canceled） `EXECUTED`（Executed） `EXPIRED`（Expired） 
cancelType | string | Cancel Type: `USER`（Cancel Type: Canceled by the user.） `INSUFFICIENT_COLLATERAL`（Canceled the settlement orders due to loss-cut.） `INSUFFICIENT_MARGIN`（Canceled the order due to insufficient margin.） `SPEED`（Canceled the order due to speed order.） `OCO`（Cancels the unexecuted side of the OCO order because the OCO order has been executed.） `EXPIRATION`（Canceled the order due to order expiration.） `PRICE_BOUND`（Canceled the order due to the upper or lower market limit price exceeded.） `OUT_OF_SLIPPAGE_RANGE`（Canceled the order due to out of slippage range.）  ※It is returned if status is `CANCELED`, or `EXPIRED`. 
expiry | string | Expiry date
timestamp | string | Ordered timestamp

<a id="active-orders"></a>
## Active Orders

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp  = Date.now().toString();
const method     = 'GET';
const endPoint   = 'https://forex-api.coin.z.com/private';
const path       = '/v1/activeOrders';
const parameters = '?symbol=USD_JPY&prevId=123456790&count=10';

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.get(endPoint + path + parameters, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": {
    "list": [
      {
        "rootOrderId": 123456789,
        "orderId": 123456789,
        "clientOrderId": "abc123",
        "symbol": "USD_JPY",
        "side": "BUY",
        "orderType": "NORMAL",
        "executionType": "LIMIT",
        "settleType": "OPEN",
        "size": "10000",
        "price": "135.5",
        "status": "ORDERED",
        "expiry": "20190418",
        "timestamp": "2019-03-19T01:07:24.217Z"
      }
    ]
  },
  "responsetime": "2019-03-19T01:07:24.217Z"
}
```

Gets active orders list of the specified symbol. 


##### Request
`GET /private/v1/activeOrders`


##### Parameters
* Parameter type: query

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`symbol`（Ticker Symbol） | string | Optional | The handling symbols are [here](#parameters-ref)
`prevId`（Previous id） | number | Optional | Order ID specify ※ If not specified, gets from the latest data.     If specified, gets data with Order ID smaller than the specified value. 
`count`（Number of items） | number | Optional | Number of items: If a count is not specified, it will run assuming 100 (maximum value) is set.

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
orderId | number | Order id
clientOrderId | string | Client order id ※Returned only when set
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `NORMAL`（Order Type: Normal order） `OCO`（OCO order） `IFD`（IFD order） `IFDOCO`（IFDOCO order） 
executionType | string | Execution Type: `LIMIT`（Execution Type: Limit order） `STOP`（Stop limit order）
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Quantity of the order
price | string | Price of the order
status | string | Order Status: `WAITING`（Order Status: Waiting） `MODIFYING`（Modifying） `ORDERED`（Valid order）　
expiry | string | Expiry date
timestamp | string | Ordered timestamp


<a id="executions"></a>
## Executions

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp  = Date.now().toString();
const method     = 'GET';
const endPoint   = 'https://forex-api.coin.z.com/private';
const path       = '/v1/executions';
const parameters = '?executionId=72123911,92123912';

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.get(endPoint + path + parameters, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": {
    "list": [
      {
        "amount":"16215.999", 
        "executionId": 92123912,
        "clientOrderId": "aaaaa",
        "orderId": 223456789,
        "positionId": 2234567,
        "symbol": "USD_JPY",
        "side": "SELL",
        "settleType": "CLOSE",
        "size": "10000",
        "price": "141.251",
        "lossGain": "15730",
        "fee": "-30",
        "settledSwap":"515.999",
        "timestamp": "2020-11-24T21:27:04.764Z"
      },
      {
        "amount":"0",
        "executionId": 72123911,
        "clientOrderId": "bbbbb",
        "orderId": 123456789,
        "positionId": 1234567,
        "symbol": "USD_JPY",
        "side": "BUY",
        "settleType": "OPEN",
        "size": "10000",
        "price": "141.269",
        "lossGain": "0",
        "fee": "0",
        "settledSwap":"0",
        "timestamp": "2020-11-24T19:47:51.234Z"
      }
    ]
  },
  "responsetime": "2019-03-19T02:15:06.081Z"
}
```

Gets executed order information of the specified order id or execution id. 

* One of `orderId`（Order id） `executionId`（Execution id） is required. Both cannot be set at the same time.


##### Request
`GET /private/v1/executions`


##### Parameters
* Parameter type: query

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`orderId`（Order id） | number | * | Either `orderId` or `executionId`（Execution id） is required.
`executionId`（Execution id） | string | * | Either `orderId`（Order id） or `executionId` is required. ※`executionId` can be up to 10, separated by commas.

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
amount | string | Delivery amount
executionId | number | Execution id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
positionId | number | Position id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Executed quantity
price | string | Executed price
lossGain | string | Settlement profit/loss
fee | string | Trade fee
settledSwap | string | Settled swap
timestamp | string | Executed timestamp


<a id="latest-executions"></a>
## Latest Executions

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp  = Date.now().toString();
const method     = 'GET';
const endPoint   = 'https://forex-api.coin.z.com/private';
const path       = '/v1/latestExecutions';
const parameters = '?symbol=USD_JPY&count=100';

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.get(endPoint + path + parameters,, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": {
    "list": [
      {
        "amount":"16215.999",
        "executionId": 92123912,
        "clientOrderId": "ccccc",
        "orderId": 223456789,
        "positionId": 2234567,
        "symbol": "USD_JPY",
        "side": "SELL",
        "settleType": "CLOSE",
        "size": "10000",
        "price": "141.251",
        "lossGain": "15730",
        "fee": "-30",
        "settledSwap":"515.999",
        "timestamp": "2020-11-24T21:27:04.764Z"
      }
    ]
  },
  "responsetime": "2019-03-19T02:15:06.086Z"
}
```

Gets the latest executed order information. 

* Returns the latest 100 contract executed order information from the past day.


##### Request
`GET /private/v1/latestExecutions`


##### Parameters
* Parameter type: query

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`symbol`（Ticker Symbol） | string | Required | The handling symbols are [here](#parameters-ref)
`count`（Number of items） | number | Optional | Number of items: If a count is not specified, it will run assuming 100 (maximum value) is set.

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
amount | string | Delivery amount
executionId | number | Execution id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
positionId | number | Position id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Executed quantity
price | string | Executed price
lossGain | string | Settlement profit/loss
fee | string | Trade fee 
settledSwap | string | Settled swap
timestamp | string | Executed timestamp


<a id="open-positions"></a>
## Open Positions

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp  = Date.now().toString();
const method     = 'GET';
const endPoint   = 'https://forex-api.coin.z.com/private';
const path       = '/v1/openPositions';
const parameters = '?symbol=USD_JPY&prevId=123456790&count=100';

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.get(endPoint + path + parameters, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": {
    "list": [
      {
        "positionId": 123456789,
        "symbol": "USD_JPY",
        "side": "BUY",
        "size": "10000",
        "orderedSize": "0",
        "price": "141.269",
        "lossGain": "-1980",
        "totalSwap":"0" ,
        "timestamp": "2019-03-21T05:18:09.011Z"
      }
    ]
  },
  "responsetime": "2019-03-19T02:15:06.095Z"
}
```

Gets a list of opened postions. 


##### Request
`GET /private/v1/openPositions`


##### Parameters
* Parameter type: query

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`symbol`（Ticker Symbol） | string | Optional | The handling symbols are [here](#parameters-ref)
`prevId`（Previous id） | number | Optional | Position ID specify ※ If not specified, gets from the latest data.     If specified, gets data with Position ID smaller than the specified value.
`count`（Number of items） | number | Optional | Number of items: If a count is not specified, it will run assuming 100 (maximum value) is set.

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
positionId | number | Position id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
size | string | Quantity of the position
orderedSize | string | Quantity of the order
price | string | Price of the position
lossGain | string | Settlement profit/loss
totalSwap | string | Total swap
timestamp | string | Executed timestamp


<a id="position-summary"></a>
## Position Summary

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp  = Date.now().toString();
const method     = 'GET';
const endPoint   = 'https://forex-api.coin.z.com/private';
const path       = '/v1/positionSummary';
const parameters = '?symbol=USD_JPY';

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.get(endPoint + path + parameters, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": {
    "list": [
      {
        "averagePositionRate": "140.043",
        "positionLossGain": "2322204.675",
        "side": "BUY",
        "sumOrderedSize": "0",
        "sumPositionSize": "1353339",
        "sumTotalSwap": "161600.404",
        "symbol": "USD_JPY"
      },
      {
        "averagePositionRate": "140.082",
        "positionLossGain": "-2588483.591",
        "side": "SELL",
        "sumOrderedSize": "20000",
        "sumPositionSize": "1481339",
        "sumTotalSwap": "-178353.217",
        "symbol": "USD_JPY"
      }
    ]
  },
  "responsetime": "2019-03-19T02:15:06.102Z"
}
```

Gets a list of the position summary. 

* It is possible to get the position summary by symbol and side (BUY/SELL).
* If you want to get the position summary of all symbols, we recommend calling out it without a symbol.


##### Request
`GET /private/v1/positionSummary`


##### Parameters
* Parameter type: query

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`symbol`（Ticker Symbol） | string | Optional | If a symbol is not specified, it will return the position summary of all symbols.  The handling symbols are [here](#parameters-ref)

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
averagePositionRate | string | Average price of the position
positionLossGain | string | Settlement profit/loss
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
sumOrderedSize | string | Total quantity of the order
sumPositionSize | string | Total quantity of the position
sumTotalSwap | string | Total swap
symbol | string | The handling symbols are [here](#parameters-ref)

## Speed Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/speedOrder';
const reqBody   = JSON.stringify({
        symbol: "USD_JPY",
        side: "BUY",
        clientOrderId: "abc123",
        size: "10000",
        upperBound: "138",
        isHedgeable: false
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json

{
  "status": 0,
  "data": [
      {
        "rootOrderId": 123456789, 
        "clientOrderId": "sygngz1234",                
        "orderId": 123456789,                      
        "symbol": "USD_JPY",　　                   
        "side": "BUY",                             
        "orderType": "NORMAL",                     
        "executionType": "MARKET",                 
        "settleType": "OPEN",                     
        "size": "10000",
        "status": "EXECUTED",                       
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      }
    ],
  "responsetime": "2019-03-19T02:15:06.069Z"
}
```

Creates a new Speed Order 


##### Request
`POST /private/v1/speedOrder`

##### Parameters
* Parameter content type: `application/json`


Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`symbol`（Ticker Symbol） | string | Required | The handling symbols are [here](#parameters-ref)
`side`（Side） | string | Required | `BUY`（Buy） `SELL`（Sell）
`clientOrderId`（Client order id） | string | Optional | Client order id ※Only combinations of up to 36 single-byte alphanumeric characters can be used.
`size`（Order size） | string | Required | Quantity of the order
`lowerBound`（Maximum price） | string | Optional  | Maximum price ※Can be specified for side:`SELL`（Side: Sell）.
`upperBound`（Minimum price） | string | Optional  | Minimum price ※Can be specified for side:`BUY`（Side: Buy）.
`isHedgeable`（No double-build: false(default)  Double-build:true） | bool | Optional  | No double-build: false(default)  Double-build:true


##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `NORMAL`（Order Type: Normal order） 
executionType | string | Execution Type: `MARKET`（Execution Type: Market order） 
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Quantity of the order
status | string | Order Status: `EXECUTED`（Order Status: Executed） `EXPIRED`（Expired）　
cancelType | string | Cancel Type: `PRICE_BOUND`（Cancel Type: Canceled the order due to the upper or lower market limit price exceeded.）  ※It is returned if status is `EXPIRED`. 
timestamp | string | Ordered timestamp


<a id="order"></a>
## Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/order';
const reqBody   = JSON.stringify({
    symbol: "USD_JPY",
    side: "BUY",
    size: "10000",
    clientOrderId: "abc123",
    executionType: "LIMIT",
    limitPrice: "130"
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
      {
        "rootOrderId": 123456789,                 
        "clientOrderId": "abc123",               
        "orderId": 123456789,                     
        "symbol": "USD_JPY",　　                  
        "side": "BUY",                            
        "orderType": "NORMAL",                    
        "executionType": "LIMIT",                  
        "settleType": "OPEN",                     
        "size": "10000",　　　　　　　                
        "price": "130",                        
        "status": "WAITING",                      
        "expiry" : "20190418",    
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      }
    ],
  "responsetime": "2019-03-19T02:15:06.059Z"
}
```

Creates a new order 


##### Request
`POST /private/v1/order`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required | Available Values
--------- | ----------- | ---------- | -----------
`symbol`（Ticker Symbol） | string | Required | The handling symbols are [here](#parameters-ref)
`side`（Side） | string | Required | `BUY`（Buy） `SELL`（Sell）
`size`（Order size） | string | Required | Quantity of the order
`clientOrderId`（Client order id） | string | Optional | Client order id ※Only combinations of up to 36 single-byte alphanumeric characters can be used.
`executionType`（Execution Type） | string | Required | `MARKET`（Market order） `LIMIT`（Limit order） `STOP`（Stop limit order） `OCO`（OCO order）
`limitPrice`（Limit order rate） | string | *Depending on executionType | Limit order rate ※Required if `LIMIT`（Execution Type: Limit order）  `OCO`（OCO order） . Not required if 
`stopPrice`（Stop order rate） | string | *Depending on executionType | Stop order rate ※Required if `STOP`（Execution Type: Stop limit order） `OCO`（OCO order）. Not required if 
`lowerBound`（Maximum price） | string | Optional | Maximum price ※Can be specified for executionType:`MARKET`（Execution Type: Market order） side: `SELL`（Side: Sell）.
`upperBound`（Minimum price） | string | Optional | Minimum price ※Can be specified for executionType:`MARKET`（Execution Type: Market order） side:`BUY`（Side: Buy）.


##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `NORMAL`（Order Type: Normal order） `OCO`（OCO order）
executionType | string | Execution Type: `MARKET`（Execution Type: Market order） `LIMIT`（Limit order） `STOP`（Stop limit order） 
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） 
size | string | Quantity of the order
price | string | Price of the order ※It is returned if status is `LIMIT`（Execution Type: Limit order） or `STOP`（Stop limit order）.
status | string | Order Status: `WAITING`（Order Status: Waiting） `EXECUTED`（Executed） `EXPIRED`（Expired） 
cancelType | string | Cancel Type: `PRICE_BOUND`（Cancel Type: Canceled the order due to the upper or lower market limit price exceeded.） `OCO`（Cancels the unexecuted side of the OCO order because the OCO order has been executed.）  ※It is returned if status is `EXPIRED`. 
expiry | string | Expiry date
timestamp | string | Ordered timestamp

<a id="ifdOrder"></a>
## Ifd Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/ifdOrder';
const reqBody   = JSON.stringify({
    symbol: "USD_JPY",
    clientOrderId: "abc123",
    firstSide: "BUY",
    firstExecutionType: "LIMIT",
    firstSize: "10000",
    firstPrice: "130",
    secondExecutionType: "LIMIT",
    secondSize: "10000",
    secondPrice: "145"
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
      {
        "rootOrderId": 123456789,                 
        "clientOrderId": "abc123",               
        "orderId": 123456789,                     
        "symbol": "USD_JPY",　　                  
        "side": "BUY",                            
        "orderType": "IFD",                    
        "executionType": "LIMIT",                  
        "settleType": "OPEN",                     
        "size": "10000",　　　　　　　                
        "price": "130",                        
        "status": "WAITING",                      
        "expiry" : "20190418",    
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      },
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456790,
        "symbol": "USD_JPY",　　                  
        "side": "SELL",
        "orderType": "IFD",
        "executionType": "LIMIT",
        "settleType": "CLOSE",
        "size": "10000",　　　　　　　                
        "price": "145",
        "status": "WAITING",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      }
  ],
  "responsetime": "2019-03-19T02:15:06.059Z"
}
```

Creates a new ifd order 


##### Request
`POST /private/v1/ifdOrder`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required | Available Values
--------- | ----------- | ---------- | -----------
`symbol`（Ticker Symbol） | string | Required | The handling symbols are [here](#parameters-ref)
`clientOrderId`（Client order id） | string | Optional | Client order id ※Only combinations of up to 36 single-byte alphanumeric characters can be used.
`firstSide`（Side） | string | Required | `BUY`（Buy） `SELL`（Sell） ※The side not specified in firstSide becomes the side of the second order. 
`firstExecutionType`（Execution Type） | string | Required | `LIMIT`（Limit order） `STOP`（Stop limit order） 
`firstSize`（Quantity of the first order） | string | Required | Quantity of the first order
`firstPrice`（First order rate） | string | Required | First order rate
`secondExecutionType`（Execution Type） | string | Required | `LIMIT`（Limit order） `STOP`（Stop limit order） 
`secondSize`（Quantity of the second order） | string | Required | Quantity of the second order
`secondPrice`（Second order rate） | string | Required | Second order rate


##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `IFD`（Order Type: IFD order）
executionType | string | Execution Type: `LIMIT`（Execution Type: Limit order） `STOP`（Stop limit order） 
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion） 
size | string | Quantity of the order
price | string | Price of the order
status | string | Order Status: `WAITING`（Order Status: Waiting） `ORDERED`（Valid order） `EXECUTED`（Executed） 
expiry | string | Expiry date
timestamp | string | Ordered timestamp


<a id="ifoOrder"></a>
## Ifdoco Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/ifoOrder';
const reqBody   = JSON.stringify({
    symbol: "USD_JPY",
    clientOrderId: "abc123",
    firstSide: "BUY",
    firstExecutionType: "LIMIT",
    firstSize: "10000",
    firstPrice: "135",
    secondSize: "10000",
    secondLimitPrice: "140",
    secondStopPrice: "132"
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
      {
        "rootOrderId": 123456789,                 
        "clientOrderId": "abc123",               
        "orderId": 123456789,                     
        "symbol": "USD_JPY",　　                  
        "side": "BUY",                            
        "orderType": "IFDOCO",                    
        "executionType": "LIMIT",                  
        "settleType": "OPEN",                     
        "size": "10000",　　　　　　　                
        "price": "135",                        
        "status": "WAITING",                      
        "expiry" : "20190418",    
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      },
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456790,
        "symbol": "USD_JPY",　　                  
        "side": "SELL",
        "orderType": "IFDOCO",
        "executionType": "LIMIT",
        "settleType": "CLOSE",
        "size": "10000",　　　　　　　                
        "price": "140",
        "status": "WAITING",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      },
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456791,
        "symbol": "USD_JPY",　　                  
        "side": "SELL",
        "orderType": "IFDOCO",
        "executionType": "STOP",
        "settleType": "CLOSE",
        "size": "10000",　　　　　　　                
        "price": "132",
        "status": "WAITING",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      }
  ],
  "responsetime": "2019-03-19T02:15:06.059Z"
}
```

Creates a new ifdoco order 


##### Request
`POST /private/v1/ifoOrder`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required | Available Values
--------- | ----------- | ---------- | -----------
`symbol`（Ticker Symbol） | string | Required | The handling symbols are [here](#parameters-ref)
`clientOrderId`（Client order id） | string | Optional | Client order id ※Only combinations of up to 36 single-byte alphanumeric characters can be used.
`firstSide`（Side） | string | Required | `BUY`（Buy） `SELL`（Sell） ※The side not specified in firstSide becomes the side of the second order. 
`firstExecutionType`（Execution Type） | string | Required | `LIMIT`（Limit order） `STOP`（Stop limit order） 
`firstSize`（Quantity of the first order） | string | Required | Quantity of the first order
`firstPrice`（First order rate） | string | Required | First order rate
`secondSize`（Quantity of the second order） | string | Required | Quantity of the second order
`secondLimitPrice`（Second limit order rate） | string | Required | Second limit order rate
`secondStopPrice`（Second stop order rate） | string | Required | Second stop order rate

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `IFDOCO`（Order Type: IFDOCO order）
executionType | string | Execution Type: `LIMIT`（Execution Type: Limit order） `STOP`（Stop limit order） 
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion） 
size | string | Quantity of the order
price | string | Price of the order
status | string | Order Status: `WAITING`（Order Status: Waiting） `ORDERED`（Valid order） `EXECUTED`（Executed） 
expiry | string | Expiry date
timestamp | string | Ordered timestamp


<a id="change-order"></a>
## Change Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/changeOrder';
const reqBody   = JSON.stringify({
    orderId: 123456789,
    price: "139"
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456789,
        "symbol": "USD_JPY",　　                  
        "side": "BUY",
        "orderType": "NORMAL",
        "executionType": "LIMIT",
        "settleType": "OPEN",
        "size": "10000",　　　　　　　                
        "price": "139",
        "status": "ORDERED",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      }
    ],
  "responsetime": "2019-03-19T02:15:06.059Z"
}
```

Changes an order. 

* One of `orderId`（Order id） `clientOrderId`（Client order id） is required. Both cannot be set at the same time.

##### Request
`POST /private/v1/changeOrder`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`orderId`（Order id） | number | * | Either `orderId` or `clientOrderId`（Client order id） is required.
`clientOrderId`（Client order id） | string | * | Either `orderId`（Order id） or `clientOrderId` is required.
`price`（Order rate） | string | Required | Order rate


##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `NORMAL`（Order Type: Normal order） 
executionType | string | Execution Type: `LIMIT`（Execution Type: Limit order） `STOP`（Stop limit order）
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Quantity of the order
price | string | Price of the order 
status | string | Order Status: `ORDERED`（Order Status: Valid order） `MODIFYING`（Modifying） `EXECUTED`（Executed） 
expiry | string | Expiry date
timestamp | string | Ordered timestamp


<a id="change-oco-order"></a>
## Change Oco Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/changeOcoOrder';
const reqBody   = JSON.stringify({
  "clientOrderId": "abc123",
  "limitPrice": "140.525",
  "stopPrice": "145.607"
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456789,
        "symbol": "USD_JPY",　　                  
        "side": "BUY",
        "orderType": "OCO",
        "executionType": "LIMIT",
        "settleType": "OPEN",
        "size": "10000",　　　　　　　                
        "price": "140.525",
        "status": "EXECUTED",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      },
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456790,
        "symbol": "USD_JPY",　　                  
        "side": "BUY",
        "orderType": "OCO",
        "executionType": "STOP",
        "settleType": "OPEN",
        "size": "10000",　　　　　　　                
        "price": "145.607",
        "status": "EXPIRED",
        "cancelType": "OCO",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      }
  ],
  "responsetime": "2019-03-19T02:15:06.059Z"
}
```

Changes an Oco order. 

* One of `rootOrderId`（Root order id） `clientOrderId`（Client order id） is required. Both cannot be set at the same time.
* Either  `limitPrice`（Limit order rate） or `stopPrice`（Stop order rate）  or both required.


##### Request
`POST /private/v1/changeOcoOrder`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`rootOrderId`（Root order id） | number | * | Either `rootOrderId` or `clientOrderId`（Client order id） is required.
`clientOrderId`（Client order id） | string | * | Either `rootOrderId`（Root order id） or `clientOrderId` is required.
`limitPrice`（Limit order rate） | string | * | Limit order rate ※ Either  `limitPrice` or `stopPrice`（Stop order rate）  or both required. 
`stopPrice`（Stop order rate） | string | * | Stop order rate ※ Either  `limitPrice`（Limit order rate） or `stopPrice`  or both required.

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `OCO`（Order Type: OCO order） 
executionType | string | Execution Type: `LIMIT`（Execution Type: Limit order） `STOP`（Stop limit order）
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Quantity of the order
price | string | Price of the order 
status | string | Order Status: `ORDERED`（Order Status: Valid order） `MODIFYING`（Modifying） `EXECUTED`（Executed） `EXPIRED`（Expired）
cancelType | string | Cancel Type: `OCO`（Cancel Type: Cancels the unexecuted side of the OCO order because the OCO order has been executed.）   ※It is returned if status is `EXPIRED`.
expiry | string | Expiry date
timestamp | string | Ordered timestamp

<a id="change-ifd-order"></a>
## Change Ifd Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/changeIfdOrder';
const reqBody   = JSON.stringify({
  "rootOrderId": 123456789,
  "firstPrice": "136.201",
  "secondPrice": "139.802"
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456789,
        "symbol": "USD_JPY",　　                  
        "side": "BUY",
        "orderType": "IFD",
        "executionType": "LIMIT",
        "settleType": "OPEN",
        "size": "10000",　　　　　　　                
        "price": "136.201",
        "status": "ORDERED",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      },
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456790,
        "symbol": "USD_JPY",　　                  
        "side": "SELL",
        "orderType": "IFD",
        "executionType": "LIMIT",
        "settleType": "CLOSE",
        "size": "10000",　　　　　　　                
        "price": "139.802",
        "status": "WAITING",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      }
  ],
  "responsetime": "2019-03-19T02:15:06.059Z"
}
```

Changes a Ifd order. 

* One of `rootOrderId`（Root order id） `clientOrderId`（Client order id） is required. Both cannot be set at the same time.
* Either  `firstPrice`（First order rate） or `secondPrice`（Second limit order rate）  or both required.


##### Request
`POST /private/v1/changeIfdOrder`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`rootOrderId`（Root order id） | number | * | Either `rootOrderId` or `clientOrderId`（Client order id） is required.
`clientOrderId`（Client order id） | string | * | Either `rootOrderId`（Root order id） or `clientOrderId` is required.
`firstPrice`（First order rate） | string | * | First order rate ※ Either  `firstPrice` or `secondPrice`（Second limit order rate）  or both required. 
`secondPrice`（Second limit order rate） | string | * | Second limit order rate ※ Either  `firstPrice`（First order rate） or `secondPrice`  or both required.

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `IFD`（Order Type: IFD order） 
executionType | string | Execution Type: `LIMIT`（Execution Type: Limit order） `STOP`（Stop limit order）
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Quantity of the order
price | string | Price of the order 
status | string | Order Status: `WAITING`（Order Status: Waiting） `ORDERED`（Valid order） `MODIFYING`（Modifying） `EXECUTED`（Executed） 
expiry | string | Expiry date
timestamp | string | Ordered timestamp


<a id="change-ifo-order"></a>
## Change Ifdoco Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/changeIfoOrder';
const reqBody   = JSON.stringify({
  "clientOrderId": "abc123",
  "firstPrice": "142.3",
  "secondLimitPrice": "136",
  "secondStopPrice": "143.1"
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456789,
        "symbol": "USD_JPY",　　                  
        "side": "SELL",
        "orderType": "IFDOCO",
        "executionType": "LIMIT",
        "settleType": "OPEN",
        "size": "10000",　　　　　　　                
        "price": "142.3",
        "status": "ORDERED",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      },
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456790,
        "symbol": "USD_JPY",　　                  
        "side": "BUY",
        "orderType": "IFDOCO",
        "executionType": "LIMIT",
        "settleType": "CLOSE",
        "size": "10000",　　　　　　　                
        "price": "136",
        "status": "WAITING",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      },
      {
        "rootOrderId": 123456789,
        "clientOrderId": "abc123",
        "orderId": 123456791,
        "symbol": "USD_JPY",　　                  
        "side": "BUY",
        "orderType": "IFDOCO",
        "executionType": "STOP",
        "settleType": "CLOSE",
        "size": "10000",　　　　　　　                
        "price": "143.1",
        "status": "WAITING",
        "expiry" : "20190418",
        "timestamp": "2019-03-19T02:15:06.059Z"　 
      }
  ],
  "responsetime": "2019-03-19T02:15:06.059Z"
}
```

Changes a Ifdoco order. 

* One of `rootOrderId`（Root order id） `clientOrderId`（Client order id） is required. Both cannot be set at the same time.
* Either or all of  `firstPrice`（First order rate） or `secondLimitPrice`（Second limit order rate）  or `secondStopPrice`（Second stop order rate）  is required.


##### Request
`POST /private/v1/changeIfoOrder`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`rootOrderId`（Root order id） | number | * | Either `rootOrderId` or `clientOrderId`（Client order id） is required.
`clientOrderId`（Client order id） | string | * | Either `rootOrderId`（Root order id） or `clientOrderId` is required.
`firstPrice`（First order rate） | string | * | First order rate ※ Either or all of  `firstPrice` or `secondLimitPrice`（Second limit order rate） or `secondStopPrice`（Second stop order rate）  is required. 
`secondLimitPrice`（Second limit order rate） | string | * | Second limit order rate ※ Either or all of  `firstPrice`（First order rate） or `secondLimitPrice`（Second limit order rate） or `secondStopPrice`（Second stop order rate）  is required.
`secondStopPrice`（Second stop order rate） | string | * | Second stop order rate ※ Either or all of  `firstPrice`（First order rate） or `secondLimitPrice`（Second limit order rate） or `secondStopPrice`（Second stop order rate）  is required.


##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `IFDOCO`（Order Type: IFDOCO order） 
executionType | string | Execution Type: `LIMIT`（Execution Type: Limit order） `STOP`（Stop limit order）
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
size | string | Quantity of the order
price | string | Price of the order 
status | string | Order Status: `WAITING`（Order Status: Waiting） `ORDERED`（Valid order） `MODIFYING`（Modifying） `EXECUTED`（Executed） `EXPIRED`（Expired）
cancelType | string | Cancel Type: `OCO`（Cancel Type: Cancels the unexecuted side of the OCO order because the OCO order has been executed.）   ※It is returned if status is `EXPIRED`.
expiry | string | Expiry date
timestamp | string | Ordered timestamp

<a id="cancel-orders"></a>
## Cancel Orders

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/cancelOrders';
const reqBody   = JSON.stringify({
    rootOrderIds: [123456789,223456789]
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": {
      "success": [
        {
          "clientOrderId": "abc123",
          "rootOrderId": 123456789
        },
        {
          "rootOrderId": 223456789
        }
      ]
  },
  "responsetime": "2019-03-19T01:07:24.557Z"
}
```

Cancels orders 

* One of `rootOrderIds`（Multiple root order IDs） `clientOrderIds`（Multiple client order id） is required. Both cannot be set at the same time.
* It is possible to cancel max 10 orders

##### Request
`POST /private/v1/cancelOrders`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required                      | Available Values
--------- | ----------- |-------------------------------| -----------
`rootOrderIds`（Multiple root order IDs） | array | * | Either `rootOrderIds` or `clientOrderIds`（Multiple client order id） is required. ※Up to 10 parent root order IDs can be specified
`clientOrderIds`（Multiple client order id） | array | * | Either `rootOrderIds`（Multiple root order IDs） or `clientOrderIds` is required. ※Up to 10 parent client order IDs can be specified

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
success | array | Root order ID and client order ID that succeeded to accept cancellation ※Client order ID returned only if set

<a id="cancel-bulk-order"></a>
## Cancel Bulk Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/cancelBulkOrder';
const reqBody   = JSON.stringify({
    symbols: ["USD_JPY","CAD_JPY"],
    side: "BUY",
    settleType: "OPEN"
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": {
    "success": [
      {
        "clientOrderId": "abc123",
        "rootOrderId": 123456789
      },
      {
        "rootOrderId": 223456789
      }
    ]
  },
  "responsetime": "2019-03-19T01:07:24.557Z"
}
```

Cancel a batch of orders (both normal and special orders). 

* After searching for cancellation targets, cancel all target orders.
* In IFD and IFDOCO cases where the first order has not been executed, the entire order will be cancelled if there is first or second order that matches both side and settleType.
* In IFD and IFDOCO cases where the first order has been executed, if the second order has both side and settleType matching, the second order is cancelled.

##### Request
`POST /private/v1/cancelBulkOrder`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
`symbols`（Ticker Symbol） | array | Required | The handling symbols are [here](#parameters-ref)
`side`（Side） | string | Optional | `BUY`（Buy） `SELL`（Sell） ※Only when parameters are specified, orders with the specified side parameter are subject to cancellation.
`settleType`（Settlement Type） | string | Optional | `OPEN`（Open position） `CLOSE`（Close postion） ※Only when parameters are specified, orders with the specified settlement type are subject to cancellation.

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
success | array | Root order ID and client order ID that succeeded to accept cancellation ※Client order ID returned only if set

<a id="close-order"></a>
## Close Order

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/closeOrder';
const reqBody   = JSON.stringify({
    "symbol": "USD_JPY",
    "side": "BUY",
    "clientOrderId": "abc123",
    "executionType": "LIMIT",
    "limitPrice": "135.5",
    "settlePosition": [
        {
            "positionId": 1000342,
            "size": "10000"
        }
    ]
})

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": [
    {
      "rootOrderId": 123456789,
      "clientOrderId": "abc123",
      "orderId": 123456789,
      "symbol": "USD_JPY",
      "side": "BUY",
      "orderType": "NORMAL",
      "executionType": "LIMIT",
      "settleType": "CLOSE",
      "size": "10000",
      "price": "135.5",
      "status": "WAITING",
      "expiry": "20230418",
      "timestamp": "2019-03-19T01:07:24.467Z"
    }
  ],
  "responsetime": "2019-03-19T01:07:24.557Z"
}
```

Closes a position 

* ※One of `size` `settlePosition` is required. Both cannot be set at the same time.


##### Request
`POST /private/v1/closeOrder`

##### Parameters
* Parameter content type: `application/json`

Parameter | Type   | Required | Available Values
--------- |--------| ----------- | -----------
`symbol`（Ticker Symbol） | string | Required | The handling symbols are [here](#parameters-ref)
`side`（Side） | string | Required | `BUY`（Buy） `SELL`（Sell）
`executionType`（Execution Type） | string | Required | `MARKET`（Market order） `LIMIT`（Limit order） `STOP`（Stop limit order） `OCO`（OCO order）
`clientOrderId`（Client order id） | string | Optional |  Client order id ※Only combinations of up to 36 single-byte alphanumeric characters can be used.
`size`（Quantity of the order） | string | * | Quantity of the order  No open interest specified. ※Either `size`  or `settlePosition`（Multi-Position） is required.
`limitPrice`（Order rate） | string | *Depending on executionType | Order rate ※Required if `LIMIT`（Execution Type: Limit order） `OCO`（OCO order） . Not required if 
`stopPrice`（Order rate） | string | *Depending on executionType | Order rate ※Required if `STOP`（Execution Type: Stop limit order） `OCO`（OCO order） . Not required if 
`lowerBound`（Maximum price） | string | Optional  | Maximum price ※Can be specified for executionType:`MARKET`（Execution Type: Market order） side: `SELL`（Side: Sell）.
`upperBound`（Minimum price） | string | Optional  | Maximum price ※Can be specified for executionType:`MARKET`（Execution Type: Market order） side: `BUY`（Side: Buy）.
`settlePostion`（Multi-Position） | array  | * | Multi-position  Multiple designations possible ※Either `size`（Quantity of the order）  or `settlePosition` is required. ※Up to 10 can be specified
`settlePosition.positionId`（Position id） | number | * | Open interest ID
`settlePosition.size`（Quantity of the order） | string | * | Quantity of the order


##### Response

Property Name | Value | Description
--------- | ----------- | -----------
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderType | string | Order Type: `NORMAL`（Order Type: Normal order） `OCO`（OCO order）
executionType | string | Execution Type: `MARKET`（Execution Type: Market order） `LIMIT`（Limit order） `STOP`（Stop limit order）
settleType | string | Settlement Type: `CLOSE`（Settlement Type: Close postion）
size | string | Quantity of the order
price | string | Price of the order ※It is returned if status is `LIMIT`（Execution Type: Limit order） or `STOP`（Stop limit order）.
status | string | Order Status: `WAITING`（Order Status: Waiting） `EXECUTED`（Executed） `EXPIRED`（Expired） 
cancelType | string | Cancel Type: `PRICE_BOUND`（Cancel Type: Canceled the order due to the upper or lower market limit price exceeded.） `OCO`（Cancels the unexecuted side of the OCO order because the OCO order has been executed.）  ※It is returned if status is `EXPIRED`.
expiry | string | Expiry date
timestamp | string | Ordered timestamp


<a id="private-ws-api"></a>
# Private WebSocket API

* A ping will be sent from the server to a client once per minute. If there's no response (pong) from a client 3 consecutive times, then the WebSocket will be disconnected automatically.
* Using a [Private API](#ws-auth-post) for authentication in order to obtain, extend and remove the access token.
* A Private WebSocket API's URL will be `Endpoint of Private WebSocket API + Access token` e.g. `wss://forex-api.coin.z.com/ws/private/v1/xxxxxxxxxxxxxxxxxxxx`

<a id="ws-auth-post"></a>
## Create Access Token

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'POST';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/ws-auth';
const reqBody   = JSON.stringify({});

const text = timestamp + method + path + reqBody;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.post(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "data": "xxxxxxxxxxxxxxxxxxxx",
  "responsetime": "2019-03-19T02:15:06.102Z"
}
```

Gets an access token to call Private WebSocket API.

* The expiration time of access token is 60 minutes.
* The maximum number of access tokens is 5.
* If the number of issued tokens exceeds the maximum number of tokens, the tokens will be deleted in order of expiration time.
* To use the API with the existing API keys, open your membership site > API > 編集 (Edit) > APIキーの編集 (API key setting) screen and click "約定情報通知(WebSocket)" (Execution Notifications), "注文情報通知(WebSocket)" (Order Notifications), "ポジション情報通知(WebSocket)" (Position Notifications) or "ポジションサマリー情報通知(WebSocket)" (Position Summary Notifications) to call the Create Access Token API.

※Please set the API key permission before obtaining the access token.


##### Request
`POST /private/v1/ws-auth`


##### Parameters
None

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
data | string | Access token


<a id="ws-auth-put"></a>
## Extend Access Token

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'PUT';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/ws-auth';
const reqBody   = JSON.stringify({
    "token": "xxxxxxxxxxxxxxxxxxxx"
})

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    }
};

axios.put(endPoint + path, reqBody, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });

```

> Response example:

```json
{
  "status": 0,
  "responsetime": "2019-03-19T02:15:06.102Z"
}
```

Extends the expiration time of an access token.

* The new expiration time is 60 minutes.


##### Request
`PUT /private/v1/ws-auth`


##### Parameters
* Parameter type: JSON

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
token | string | Required | Access token


<a id="ws-auth-delete"></a>
## Delete Access Token

> Request example:

```javascript
const axios  = require('axios');
const crypto = require('crypto');

const apiKey    = 'YOUR_API_KEY';
const secretKey = 'YOUR_SECRET_KEY';

const timestamp = Date.now().toString();
const method    = 'DELETE';
const endPoint  = 'https://forex-api.coin.z.com/private';
const path      = '/v1/ws-auth';
const reqBody   = JSON.stringify({
    "token": "xxxxxxxxxxxxxxxxxxxx"
})

const text = timestamp + method + path;
const sign = crypto.createHmac('sha256', secretKey).update(text).digest('hex');
const options = {
    "headers": {
        "API-KEY": apiKey,
        "API-TIMESTAMP": timestamp,
        "API-SIGN": sign
    },
    "data": reqBody,
};

axios.delete(endPoint + path, options)
  .then(function (response) {
    console.log(JSON.stringify(response.data, null, 2));
  })
  .catch(function (error) {
    console.log(error);
  });
```

> Response example:

```json
{
  "status": 0,
  "responsetime": "2019-03-19T02:15:06.102Z"
}
```

Deletes an access token.


##### Request
`DELETE /private/v1/ws-auth`


##### Parameters
* Parameter type: JSON

Parameter | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
token | string | Required | Access token


<a id="ws-execution-events"></a>
## Execution Notifications

> Request example:

```javascript
const WebSocket = require("ws");
const ws = new WebSocket("wss://forex-api.coin.z.com/ws/private/v1/xxxxxxxxxxxxxxxxxxxx");

ws.on("open", () => {
    const message = JSON.stringify(
    {
        "command": "subscribe",
        "channel": "executionEvents"
    });
    ws.send(message);
});

ws.on("message", (data) => {
    console.log("WebSocket message: ", data);
});
```

> Response example:

```json
{
  "channel": "executionEvents",
  "amount": "-30",
  "rootOrderId": 123456789,
  "orderId": 123456789,
  "clientOrderId": "abc123",
  "executionId": 72123911,
  "symbol": "USD_JPY",
  "settleType": "OPEN",
  "orderType":  "NORMAL",
  "executionType": "LIMIT",
  "side": "BUY",
  "executionPrice": "138.963",
  "executionSize": "10000",
  "positionId": 123456789,
  "lossGain": "0",
  "settledSwap": "0",
  "fee": "-30",
  "orderPrice": "140",
  "orderExecutedSize": "10000",
  "orderSize": "10000",
  "msgType": "ER",
  "orderTimestamp": "2019-03-19T02:15:06.081Z",
  "executionTimestamp": "2019-03-19T02:15:06.081Z"
}
```

Receives latest execution events notifications. 
After `subscribe`（WebSocket Command: Start subscribing）, latest execution events notification will be sent.


##### Parameters
* Parameter type: JSON

Property Name | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
command | string | Required | `subscribe`（WebSocket Command: Start subscribing） `unsubscribe`（Stop subscribing）
channel | string | Required | `executionEvents`（Channel Name: Execution Notifications）

##### Response

Property Name | Value  | Description
--------- |--------| -----------
channel | string | `executionEvents`（Channel Name: Execution Notifications）
amount | string | Delivery amount
rootOrderId | number | Root order id
orderId | number | Order id
clientOrderId | string | Client order id ※Returned only when set
executionId | number | Execution id
symbol | string | The handling symbols are [here](#parameters-ref)
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion）
orderType | string | Order Type: `NORMAL`（Order Type: Normal order） `OCO`（OCO order） `IFD`（IFD order） `IFDOCO`（IFDOCO order） `LOSSCUT`（Margin liquidation） 
executionType | string | Execution Type: `MARKET`（Execution Type: Market order） `LIMIT`（Limit order） `STOP`（Stop limit order）
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
executionPrice | string | Executed price
executionSize | string | Executed quantity
positionId | number | Position id
lossGain | string | Settlement profit/loss
settledSwap | string | Settlement profit/loss of swap
fee | string | Trade fee 
orderPrice | string | Price of the order ※It is returned if status is `LIMIT`（Execution Type: Limit order） or `STOP`（Stop limit order）.
orderExecutedSize | string | Contracted Quantity
orderSize | string | Order size
msgType | string | Message Type: `ER`（Message Type: Executed）
orderTimestamp | string | Ordered timestamp
executionTimestamp | string | Executed timestamp

* There is no Response when `unsubscribe`（WebSocket Command: Stop subscribing） is requested.


<a id="ws-order-events"></a>
## Order Notifications

> Request example:

```javascript
const WebSocket = require("ws");
const ws = new WebSocket("wss://forex-api.coin.z.com/ws/private/v1/xxxxxxxxxxxxxxxxxxxx");

ws.on("open", () => {
    const message = JSON.stringify(
    {
        "command": "subscribe",
        "channel": "orderEvents"
    });
    ws.send(message);
});

ws.on("message", (data) => {
    console.log("WebSocket message: ", data);
});
```

> Response example:

```json
{
  "channel": "orderEvents",
  "rootOrderId": 123456789,
  "clientOrderId":"abc123",
  "orderId": 123456789,
  "symbol": "USD_JPY",
  "settleType": "OPEN",
  "orderType":  "NORMAL",
  "executionType": "LIMIT",
  "side": "BUY",
  "orderStatus": "ORDERED",
  "orderTimestamp": "2019-03-19T02:15:06.081Z",
  "orderPrice": "135",
  "orderSize": "10000",
  "expiry" : "20190418", 
  "msgType": "NOR"
}
```

Receives latest order events notifications. 
After `subscribe`（WebSocket Command: Start subscribing）, latest order events notification will be sent.


##### Parameters
* Parameter type: JSON

Property Name | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
command | string | Required | `subscribe`（WebSocket Command: Start subscribing） `unsubscribe`（Stop subscribing）
channel | string | Required | `orderEvents`（Channel Name: Order Notifications）

##### Response

Property Name | Value | Description
--------- | ----------- | -----------
channel | string | `orderEvents`（Channel Name: Order Notifications）
rootOrderId | number | Root order id
clientOrderId | string | Client order id ※Returned only when set
orderId | number | Order id
symbol | string | The handling symbols are [here](#parameters-ref)
settleType | string | Settlement Type: `OPEN`（Settlement Type: Open position） `CLOSE`（Close postion） `LOSS_CUT`（Margin liquidation）
orderType | string | Order Type: `NORMAL`（Order Type: Normal order） `OCO`（OCO order） `IFD`（IFD order） `IFDOCO`（IFDOCO order） `LOSSCUT`（Margin liquidation） 
executionType | string | Execution Type: `MARKET`（Execution Type: Market order） `LIMIT`（Limit order） `STOP`（Stop limit order）
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
orderStatus | string | Order Status: `WAITING`（Order Status: Waiting） `ORDERED`（Valid order） `CANCELED`（Canceled） `EXPIRED`（Expired） 
cancelType | string | Cancel Type: `USER`（Cancel Type: Canceled by the user.） `INSUFFICIENT_COLLATERAL`（Canceled the settlement orders due to loss-cut.） `INSUFFICIENT_MARGIN`（Canceled the order due to insufficient margin.） `SPEED`（Canceled the order due to speed order.） `OCO`（Cancels the unexecuted side of the OCO order because the OCO order has been executed.） `EXPIRATION`（Canceled the order due to order expiration.） `PRICE_BOUND`（Canceled the order due to the upper or lower market limit price exceeded.） `OUT_OF_SLIPPAGE_RANGE`（Canceled the order due to out of slippage range.）  ※It is returned if status is `CANCELED`, or `EXPIRED`.
orderTimestamp | string | Ordered timestamp
orderPrice | string | Price of the order ※It is returned if status is `LIMIT`（Execution Type: Limit order） or `STOP`（Stop limit order）.
orderSize | string | Ordered size
expiry | string | Expiry date
msgType | string | Message Type: `NOR`（Message Type: New Order Response） `ROR`（Replace Order Response） `COR`（Cancel Order Response） 

* There is no Response when `unsubscribe`（WebSocket Command: Stop subscribing） is requested.

<a id="ws-position-events"></a>
## Position Notifications

> Request example:

```javascript
const WebSocket = require("ws");
const ws = new WebSocket("wss://forex-api.coin.z.com/ws/private/v1/xxxxxxxxxxxxxxxxxxxx");

ws.on("open", () => {
    const message = JSON.stringify(
    {
        "command": "subscribe",
        "channel": "positionEvents"
    });
    ws.send(message);
});

ws.on("message", (data) => {
    console.log("WebSocket message: ", data);
});
```

> Response example:

```json
{
  "channel": "positionEvents",
  "positionId": 1234567,
  "symbol": "USD_JPY",
  "side": "BUY",
  "size": "500",
  "orderdSize": "0",
  "price": "139.772",
  "lossGain": "-553.5",
  "timestamp": "2019-03-19T02:15:06.094Z",
  "totalSwap":"-34.4",
  "msgType": "UPR"
}
```

Receives latest position events notifications. 
After `subscribe`（WebSocket Command: Start subscribing）, latest position events notification will be sent.


##### Parameters
* Parameter type: JSON

Property Name | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
command | string | Required | `subscribe`（WebSocket Command: Start subscribing） `unsubscribe`（Stop subscribing）
channel | string | Required | `positionEvents`（Channel Name: Position Notifications）


##### Response

Property Name | Value | Description
--------- | ----------- | -----------
channel | string | `positionEvents`（Channel Name: Position Notifications）
positionId | number | Position id
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
size | string | Quantity of the position
orderdSize | string | Quantity of the order
price | string | Price of the position
lossGain | string | Settlement profit/loss
timestamp | string | Executed timestamp
totalSwap | string | Total swap
msgType | string | Message Type: `OPR`（Message Type: Opened Position） `UPR`（Partially Executed Position） `CPR`（Closed Position）

* There is no Response when `unsubscribe`（WebSocket Command: Stop subscribing） is requested.

<a id="ws-position-summary-events"></a>
## Position Summary Notifications

> Request example:

```javascript
const WebSocket = require("ws");
const ws = new WebSocket("wss://forex-api.coin.z.com/ws/private/v1/xxxxxxxxxxxxxxxxxxxx");

ws.on("open", () => {
    const message = JSON.stringify(
    {
        "command": "subscribe",
        "channel": "positionSummaryEvents",
        "option":"PERIODIC"
    });
    ws.send(message);
});

ws.on("message", (data) => {
    console.log("WebSocket message: ", data);
});
```

> Response example:

```json
{
  "channel":"positionSummaryEvents",
  "symbol":"USD_JPY",
  "side":"BUY",
  "averagePositionRate":"138.877",
  "positionLossGain":"3644808.1",
  "sumOrderedSize":"8000",
  "sumPositionSize":"1821000",
  "sumTotalSwap": "167407.6",
  "timestamp":"2020-06-24T09:53:19.702Z",
  "msgType":"PERIODIC"
}
```

Receives latest position summary events notifications. 
After `subscribe`（WebSocket Command: Start subscribing）, latest position summary events notification will be sent.


##### Parameters
* Parameter type: JSON

Property Name | Type | Required | Available Values
--------- | ----------- | ----------- | -----------
command | string | Required | `subscribe`（WebSocket Command: Start subscribing） `unsubscribe`（Stop subscribing）
channel | string | Required | `positionSummaryEvents`（Channel Name: Position Summary Notifications）
option | string | Optional | `PERIODIC`（Option: Send periodic data.） ※If option is specified, it will send data every 5 seconds. ※If you request multiple subscriptions, only the latest request will be valid.


#### Response

Property Name | Value | Description
--------- | ----------- | -----------
channel | string | `positionSummaryEvents`（Channel Name: Position Summary Notifications）
symbol | string | The handling symbols are [here](#parameters-ref)
side | string | Side: `BUY`（Side: Buy） `SELL`（Sell）
averagePositionRate | string | Average price of the position
positionLossGain | string | Settlement profit/loss
sumOrderedSize | string | Quantity of the order
sumPositionSize | string | Total quantity of the position
sumTotalSwap | string | Total swap
timestamp | string | Timestamp of the notifications
msgType | string | Message Type: `INIT`（Message Type: Initial data） `UPDATE`（Updated data） `PERIODIC`（Periodic data）

* There is no Response when `unsubscribe`（WebSocket Command: Stop subscribing） is requested.


<a id="references"></a>
# References

This section explains about codes, which are API parameters and response values.

<a id="parameters-ref"></a>
## Parameters

This section explains about parameters and their details.

###  
symbol: Trading symbol

Value | Description                   | Release date
----- |-------------------------------| -----
USD_JPY | US Dollar/Japanese Yen | 2023/04/26
EUR_JPY | Euro/Japanese Yen | 2023/04/26
GBP_JPY | British Pound/Japanese Yen | 2023/04/26
AUD_JPY | Australian Dollar/Japanese Yen | 2023/04/26
NZD_JPY | New Zealand Dollar/Japanese Yen | 2023/04/26
CAD_JPY | Canadian Dollar/Japanese Yen | 2023/04/26
CHF_JPY | Swiss Franc/Japanese Yen | 2023/04/26
TRY_JPY | Turkish Lira/Japanese Yen | 2023/08/05
ZAR_JPY | South African Rand/Japanese Yen | 2023/08/05
MXN_JPY | Mexican Peso/Japanese Yen | 2023/08/05
HUF_JPY | Hungarian Forint/Japanese Yen | 2026/05/16
SEK_JPY | Swedish Krona/Japanese Yen | 2026/05/16
EUR_USD | Euro/US Dollar | 2023/04/26
GBP_USD | British Pound/US Dollar | 2023/04/26
AUD_USD | Australian Dollar/US Dollar | 2023/04/26
NZD_USD | New Zealand Dollar/US Dollar | 2023/04/26
EUR_GBP | Euro/British Pound | 2026/05/16
AUD_NZD | Australian Dollar/New Zealand Dollar | 2026/05/16
AUD_CAD | Australian Dollar/Canadian Dollar | 2026/05/16
NZD_CAD | New Zealand Dollar/Canadian Dollar | 2026/05/16
NOK_SEK | Norwegian Krone/Swedish Krona | 2026/05/16

#### side: Side

Value | Description
----- | -----
BUY | Buy
SELL | Sell

#### executionType: Execution Type

Value | Description
----- | -----
MARKET | Market order
LIMIT  | Limit order
STOP  | Stop limit order

<a id="http-status-code"></a>
## HTTP Status Codes
Status Code | Description
------------- | -----
200 | A response for successful HTTP requests.
404 | `A response for when requested URL is invalid.`（e.g. There is an incorrect part in a URL at private/public part such as 'https://forex-api.coin.z.com/publlic/v1/status'.）
503 | A response code that when WebSocket API is called while the service is in maintenance.

<a id="status-code"></a>
## Status Codes

Status Code | Description
------------| -----------------------------
0           | A response for successful API processing.

<a id="error-code"></a>
## Error Codes

Error Code | Description
---------- | -----
ERR-143  | Currently trade restriction. Cannot trade.
ERR-148  | The settlement size exceeds the new order size.
ERR-189  | The quantity of your close order exceeds your open position.
ERR-200  | There are existing active orders and your order exceeds the maximum quantity that can be ordered. Please change the quantity to order or [cancel an active order](#cancel-orders) in order to create a new [close order](#close-order).
ERR-201  | Insufficient funds.
ERR-254  | The specified position does not exist.
ERR-414  | Request positionID mismatched symbol.
ERR-423  | Exceeds settle quantity.
ERR-512  | Duplicate positionID settlement request.
ERR-542  | Cannot change non-OCO order.
ERR-595  | Cannot change non-IFO/IFD order.
ERR-635  | The number of active orders has exceeded the limit. Please [cancel an active order](#cancel-orders) to create a new [order](#order).
ERR-759  | Active contract count restriction. 
ERR-760  | No prices are changed. 
ERR-761  | The order price exceeds the price limit range.
ERR-769  | The specified order has expired.
ERR-786  | This clientOrderId is in use by your other active order.
ERR-5003 | The API usage limits are exceeded.
ERR-5008 | The API-TIMESTAMP set in the request header is later than the system time of the API. Please try updating the system time.
ERR-5009 | The API-TIMESTAMP set in the request header is earlier than the system time of the API. Please try updating the system time.
ERR-5010 | The API-SIGN (Signature) is invalid. Please check [Authentication](#authentication).
ERR-5011 | The API-KEY is empty. Please check [Authentication](#authentication).
ERR-5012 | The API authentication is invalid.
ERR-5014 | The membership agreement has not been completed.
ERR-5106 | The request parameter is invalid.
ERR-5114 | The number of decimals exceeds tick size. Please check tick size [here](https://coin.z.com/jp/corp/product/info/fx/#rule).
ERR-5122 | The specified order can not be changed or canceled (already MODIFYING, CANCELLING, CANCELED, EXECUTED or EXPIRED). Orders can be changed or canceled only in ORDERED (WAITING for stop limit orders) status.
ERR-5123 | The specified order doesn't exist.
ERR-5125 | Returned when there is API restriction.
ERR-5126 | The amount exceeds the maximum order amount or is less than the minimum order amount. Please check the trading rules [here](https://coin.z.com/jp/corp/product/info/fx/#rule). (Note that the minimum order amount for the API differs from that in the web platform and mobile app.)
ERR-5130 | The orderID(s) exceeds the number that can be specified.
ERR-5132 | The executionID(s) exceeds the number that can be specified.
ERR-5201 | A response code that when Public/Private API is called while the service is in a regular maintenance.
ERR-5202 | A response code that when Public/Private API is called while the service is in a emergency maintenance.
ERR-5204 | `The request API PATH is invalid.`（e.g. The request URL after the private/public part is invalid such as 'https://forex-api.coin.z.com/public/public/v1/status'.）
ERR-5206 | The limits of changing order for each order are exceeded. If you would like further changes for the order, please [cancel the order](#cancel-orders) and create a brand new [order](#order).
ERR-5207 | Invalid symbol, interval or date values.
ERR-5208 | OrderId(s) and executionId(s) cannot be used at the same time.
ERR-5209 | OrderId(s) and rootOrderId(s) cannot be used at the same time.
ERR-5210 | Invalid combination of executionType stopPrice limitPrice
ERR-5211 | LowerBound or UpperBound cannot be specified for side or executionType.
ERR-5213 | RootOrderId and ClientOrderId cannot be used at the same time.
ERR-5214 | Size must not be specified.
ERR-5218 | The order was rejected for trading close.
ERR-5219 | Cannot change non-normal order.
ERR-5220 | Set the secondPrice higher than the firstPrice.
ERR-5221 | Set the secondPrice lower than the firstPrice.
ERR-5222 | Set the secondLimitPrice higher than the firstPrice.
ERR-5223 | Set the secondLimitPrice lower than the firstPrice.
ERR-5224 | Set the secondStopPrice lower than the firstPrice.
ERR-5225 | Set the secondStopPrice higher than the firstPrice.
ERR-5226 | Please set the stop price higher than current price.
ERR-5227 | Please set the stop price lower than current price.
ERR-5228 | Please set the stop price lower than the limit price.
ERR-5229 | Please set the stop price higher than the limit price.

<a id="feedback"></a>
# Feedback
We'd like to hear some feedback about our API. Your feedback will be carefully reviewed by our development team, to be developed and released sequentially. Please click [here](https://support.coin.z.com/hc/ja/requests/new?ticket_form_id=360002450434) to contact us about any requests you may have about the API.

※Please click [here](https://support.coin.z.com/hc/ja/requests/new) to contact us about API inquiries. We may take some time to respond depending on the inquiry. Thank you for your understanding.


<a id="changelogs"></a>
# Changelog

## 2026

###   2026-05-16 New
Added Hungarian Forint/JPY, Swedish Krona/JPY, Euro/British Pound, Australian Dollar/New Zealand Dollar, Australian Dollar/Canadian Dollar, New Zealand Dollar/Canadian Dollar, Norwegian Krone/Swedish Krona.
* **Parameter and Response `symbol`（Ticker Symbol）: added **`HUF_JPY`（Hungarian Forint/Japanese Yen） `SEK_JPY`（Swedish Krona/Japanese Yen） `EUR_GBP`（Euro/British Pound） `AUD_NZD`（Australian Dollar/New Zealand Dollar） `AUD_CAD`（Australian Dollar/Canadian Dollar） `NZD_CAD`（New Zealand Dollar/Canadian Dollar） `NOK_SEK`（Norwegian Krone/Swedish Krona）**.**

## 2023

###   2023-12-16
The samples have been updated to correspond to the latest versions of each language as of December 16, 2023.

###   2023-10-28
Version v1 has been released.

